<?php

namespace Simpler\Http\Schemas;

final class QuotationSchema
{
    public static $schema
        = [
            '$schema'    => 'http://json-schema.org/draft-04/schema#',
            'title'      => 'order quote',
            'type'       => 'object',
            'properties' => [
                'items'  => [
                    'type'     => 'array',
                    'required' => true,
                    'minItems' => 1,
                    'items'    => [
                        'type'       => 'object',
                        'required'   => true,
                        'properties' => [
                            'product_id' => [
                                'type'     => 'number',
                                'min'      => 1,
                                'required' => true,
                            ],
                            'quantity'   => [
                                'type'     => 'number',
                                'required' => true,
                                'min'      => 1,
                            ],
                        ],
                    ],
                ],
                'coupon' => [
                    'type' => 'string',
                ],
                'shipto' => [
                    'type'       => 'object',
                    'properties' => [
                        'country'  => [
                            'type'     => 'string',
                            'required' => true,
                        ],
                        'state'    => [
                            'type' => 'string',
                        ],
                        'postcode' => [
                            'type'     => 'string',
                            'required' => true,
                        ],
                        'city'     => [
                            'type'     => 'string',
                            'required' => true,
                        ],
                        'address'  => [
                            'type'     => 'string',
                            'required' => true,
                        ],
                    ],
                ],
            ],
        ];
}
