<?php

namespace Simpler\Models;

final class CartItem
{
    /**
     * @var int
     */
    private $product_id;
    /**
     * @var int
     */
    private $quantity;

    public function __construct($product_id, $quantity)
    {
        $this->product_id = $product_id;
        $this->quantity   = $quantity;
    }

    public static function from_json(array $json)
    {
        return new CartItem($json['product_id'], $json['quantity']);
    }

    public function get_product_id()
    {
        return absint($this->product_id);
    }

    public function get_quantity()
    {
        return absint($this->quantity);
    }
}
