<?php

add_action('init', 'simplerwc_load_settings');
add_action('admin_init', 'simplerwc_load_settings_form');

function simplerwc_load_settings()
{
    register_setting('simpler_management', 'simpler_api_key', [
        'type' => 'string'
    ]);

    register_setting('simpler_management', 'simpler_api_secret', [
        'type' => 'string'
    ]);

    register_setting('simpler_management', 'simpler_checkout_test_mode', [
        'type' => 'number',
        'default' => 1
    ]);

    register_setting('simpler_button', 'simpler_auto_render_product_button', [
        'type' => 'number',
        'default' => 1
    ]);

    register_setting('simpler_button', 'simplerwc_product_button_placement', [
        'type'    => 'string',
        'default' => 'woocommerce_after_add_to_cart_quantity',
    ]);

    register_setting('simpler_button', 'simpler_auto_render_cart_button', [
        'type' => 'number',
        'default' => 1
    ]);

    register_setting('simpler_styling', 'simpler_product_button_custom_style', [
        'type' => 'string',
    ]);

    register_setting('simpler_styling', 'simpler_mini_cart_button_custom_style', [
        'type' => 'string',
    ]);

    register_setting('simpler_styling', 'simpler_cart_page_button_custom_style', [
        'type' => 'string',
    ]);

    register_setting('simpler_styling', 'simpler_checkout_page_button_custom_style', [
        'type' => 'string',
    ]);
}

function simplerwc_load_settings_form()
{
    add_settings_section(
        'simpler_credentials',
        'Credentials',
        'simplerwc_credentials_config',
        'simpler_management'
    );

    add_settings_field(
        'simpler_api_key',
        'Simpler API Key',
        'simplerwc_echo_simpler_api_key_input',
        'simpler_management',
        'simpler_credentials'
    );

    add_settings_field(
        'simpler_api_secret',
        'Simpler API Secret',
        'simplerwc_echo_simpler_api_secret_input',
        'simpler_management',
        'simpler_credentials'
    );

    add_settings_section(
        'simpler_custom_styles',
        'Simpler Button Custom Styling (Advanced)',
        'simplerwc_custom_styles',
        'simpler_styling'
    );

    add_settings_field(
        'simpler_product_button_custom_style',
        'Product Page',
        'simplerwc_echo_simpler_product_button_custom_style',
        'simpler_styling',
        'simpler_custom_styles'
    );

    add_settings_field(
        'simpler_mini_cart_button_custom_style',
        'Mini Cart',
        'simplerwc_echo_simpler_mini_cart_button_custom_style',
        'simpler_styling',
        'simpler_custom_styles'
    );

    add_settings_field(
        'simpler_cart_page_button_custom_style',
        'Cart Page',
        'simplerwc_echo_simpler_cart_page_button_custom_style',
        'simpler_styling',
        'simpler_custom_styles'
    );

    add_settings_field(
        'simpler_checkout_page_button_custom_style',
        'Checkout Page',
        'simplerwc_echo_simpler_checkout_page_button_custom_style',
        'simpler_styling',
        'simpler_custom_styles'
    );

    add_settings_section(
        'simpler_debugging',
        'Advanced Settings',
        'simplerwc_debug_config',
        'simpler_management'
    );


    add_settings_field(
        'simpler_checkout_test_mode',
        'Test Mode?',
        'simplerwc_echo_simpler_checkout_test_mode',
        'simpler_management',
        'simpler_debugging'
    );

    add_settings_section(
        'simpler_product_button',
        'Single Product Checkout Button',
        'simplerwc_product_button',
        'simpler_button'
    );

    add_settings_field(
        'simpler_auto_render_product_button',
        'Automatically render button in product page',
        'simplerwc_echo_simpler_auto_render_product_button',
        'simpler_button',
        'simpler_product_button'
    );

    add_settings_field(
        'simplerwc_product_button_placement',
        'Product button placement',
        'simplerwc_echo_product_button_placement_select',
        'simpler_button',
        'simpler_product_button'
    );

    add_settings_section(
        'simpler_cart_button',
        'Cart Checkout Button',
        'simplerwc_cart_button',
        'simpler_button'
    );

    add_settings_field(
        'simplerwc_auto_render_cart_button',
        'Automatically render button in cart checkout pages',
        'simplerwc_echo_simplerwc_auto_render_cart_button',
        'simpler_button',
        'simpler_cart_button'
    );

    add_settings_section(
        'simpler_shortcodes',
        'Shortcodes',
        'simplerwc_echo_shortcodes_settings',
        'simpler_shortcodes',
    );
}

function simplerwc_credentials_config()
{
}

function simplerwc_custom_styles()
{
    echo '<hr class="divider" />';
}

function simplerwc_product_button()
{
    echo '<hr class="divider" />';
}

function simplerwc_cart_button()
{
    echo '<hr class="divider" />';
}

function simplerwc_debug_config()
{
    echo '<hr class="divider" />';
}

function simplerwc_echo_shortcodes_settings()
{ ?>
    <p style="font-size:1rem;">If you are an advanced user, you can use <a href="https://wordpress.com/support/shortcodes/">shortcodes</a> to control button placement in a more flexible way. Simpler provides two shortcodes :</p>
    <ul style="padding: 32px 8px;">
        <li>
            <h5><code>[simpler-product-checkout]</code></h5>
            <p>
                This shortcode will render a checkout button that will open up Simpler Checkout for the product in the current context. If there is no product in the context (for example in a static page), you can use the product_id attribute to hardcode a product.
            </p>
            <p>
                If you are using a hardcoded product id for a variable product, you will need to supply the variation id. Feel free to reach out to <a href="mailto:support@simpler.so">support@simpler.so</a> for support.
            </p>
        </li>
        <li>
            <h5><code>[simpler-cart-checkout]</code></h5>
            <p>
                This shortcode will render a checkout button that will open up a Simpler Checkout for the <strong>current cart</strong>. It is useful for checkout pages, where customers may have added multiple products to their carts.
        </li>
    </ul>
    <p style="font-size:1rem;">
        If you decide to use shortcodes, we suggest you turn off the 'Auto-render' settings in the <a href="?page=simpler_management&tab=simpler_button">button settings tab</a>.
    </p>
<?php }

function simplerwc_echo_simpler_api_key_input()
{
    echo '<input name="simpler_api_key" id="simpler_api_key" type="text" style="min-width: 35%;" value="' . esc_html(get_option('simpler_api_key')) . '" />';
}

function simplerwc_echo_simpler_api_secret_input()
{
    echo '<input name="simpler_api_secret" id="simpler_api_key" type="text" style="min-width: 35%;" value="' . esc_html(get_option('simpler_api_secret')) . '" />';
}

function simplerwc_echo_simpler_product_button_custom_style()
{
    echo '<textarea name="simpler_product_button_custom_style" id="simpler_product_button_custom_style" cols=28 rows=10>' . esc_textarea(get_option('simpler_product_button_custom_style')) . '</textarea>';
}

// https://www.businessbloomer.com/woocommerce-visual-hook-guide-single-product-page/
function simplerwc_echo_product_button_placement_select()
{
    $current = get_option('simplerwc_product_button_placement');
?>
    <select name="simplerwc_product_button_placement">
        <option value="woocommerce_before_add_to_cart_form" <?php selected($current, 'woocommerce_before_add_to_cart_form') ?>>Before Add To Cart Form</option>
        <option value="woocommerce_after_add_to_cart_form" <?php selected($current, 'woocommerce_after_add_to_cart_form') ?>>After Add To Cart Form</option>
        <option value="woocommerce_before_add_to_cart_quantity" <?php selected($current, 'woocommerce_before_add_to_cart_quantity') ?>>Before Quantity</option>
        <option value="woocommerce_after_add_to_cart_quantity" <?php selected($current, 'woocommerce_after_add_to_cart_quantity') ?>>After Quantity</option>
        <option value="woocommerce_after_add_to_cart_button" <?php selected($current, 'woocommerce_after_add_to_cart_button') ?>>After Add To Cart Button</option>
        <option value="woocommerce_after_single_product_summary" <?php selected($current, 'woocommerce_after_single_product_summary') ?>>After Product Summary</option>
    </select>
<?php }

function simplerwc_echo_simplerwc_auto_render_cart_button()
{
    $html = '<div>';
    $html .= '<input type="checkbox" id="simpler_auto_render_cart_button" name="simpler_auto_render_cart_button" value="1" ' . checked(1, get_option('simpler_auto_render_cart_button'), false) . ' />';
    $html .= '<label for="simpler_auto_render_cart_button">Automatically render checkout button in cart checkout pages</label>';
    $html .= '</div><div>';
    $html .= '<small>Disable this if you are using the [simpler-cart-checkout] shortcode to render the checkout button.</small>';
    $html .= '</div>';
    echo $html;
}

function simplerwc_echo_simpler_mini_cart_button_custom_style()
{
    echo '<textarea name="simpler_mini_cart_button_custom_style" id="simpler_mini_cart_button_custom_style" cols=28 rows=10>' . esc_textarea(get_option('simpler_mini_cart_button_custom_style')) . '</textarea>';
}

function simplerwc_echo_simpler_cart_page_button_custom_style()
{
    echo '<textarea name="simpler_cart_page_button_custom_style" id="simpler_cart_page_button_custom_style" cols=28 rows=10>' . esc_textarea(get_option('simpler_cart_page_button_custom_style')) . '</textarea>';
}

function simplerwc_echo_simpler_checkout_page_button_custom_style()
{
    echo '<textarea name="simpler_checkout_page_button_custom_style" id="simpler_checkout_page_button_custom_style" cols=28 rows=10>' . esc_textarea(get_option('simpler_checkout_page_button_custom_style')) . '</textarea>';
}

function simplerwc_echo_simpler_auto_render_product_button()
{
    $html = '<div>';
    $html .= '<input type="checkbox" id="simpler_auto_render_product_button" name="simpler_auto_render_product_button" value="1" ' . checked(1, get_option('simpler_auto_render_product_button'), false) . ' />';
    $html .= '<label for="simpler_auto_render_product_button">Automatically render checkout button in product pages</label>';
    $html .= '</div><div>';
    $html .= '<small>Disable this if you are using the [simpler-product-checkout] shortcode to render the checkout button.</small>';
    $html .= '</div>';
    echo $html;
}

function simplerwc_echo_simpler_checkout_test_mode()
{
    $html = '<div>';
    $html .= '<input type="checkbox" id="simpler_checkout_test_mode" name="simpler_checkout_test_mode" value="1" ' . checked(1, get_option('simpler_checkout_test_mode'), false) . ' />';
    $html .= '<label for="simpler_checkout_test_mode">Test Mode?</label>';
    $html .= '</div><div>';
    $html .= '<small>When Test Mode is enabled only logged in administrators will be able to see the Simpler Checkout buttons.</small>';
    $html .= '</div>';
    echo $html;
}

add_action('admin_menu', 'simplerwc_init_simpler_admin_dashboard');

function simplerwc_init_simpler_admin_dashboard()
{
    add_submenu_page(
        'options-general.php',
        'SimplerCheckout',
        'Simpler Checkout',
        'manage_options',
        'simpler_management',
        'simplerwc_render_homepage',
        100,
        100
    );
}

function simplerwc_render_homepage()
{
    $tab = isset($_GET['tab']) ? $_GET['tab'] : 'simpler_management';
?>
    <div class="wrap">
        <h1 style="font-weight: 600; margin: 2rem 0;">Simpler. 1-Click Checkout</h1>
        <p>
            The Simpler 1-Click Checkout button lets your customers complete their purchases in seconds.
            Customers using Simpler for the first time will fill in a simple form once.
            For all their next purchases, they can complete their orders with 1 click, regardless of device or browser, and without a password.
        </p>
        <p>
            You can configure your Simpler integration here.
            <span style="font-size:.8rem;">Questions? Contact us at <a href="mailto:support@simpler.so">support@simpler.so</a></span>
        </p>
        <h2 class="nav-tab-wrapper">
            <a class="nav-tab <?php echo $tab == 'simpler_management' ? 'nav-tab-active' : '' ?>" href="?page=simpler_management&tab=simpler_management">Basic Configuration</a>
            <a class="nav-tab <?php echo $tab == 'simpler_button' ? 'nav-tab-active' : '' ?>" href="?page=simpler_management&tab=simpler_button">Button</a>
            <a class="nav-tab <?php echo $tab == 'simpler_styling' ? 'nav-tab-active' : '' ?>" href="?page=simpler_management&tab=simpler_styling">Advanced Styling</a>
            <a class="nav-tab <?php echo $tab == 'simpler_shortcodes' ? 'nav-tab-active' : '' ?>" href="?page=simpler_management&tab=simpler_shortcodes">Shortcodes</a>
        </h2>
        <form action="<?php echo esc_url(admin_url('options.php')); ?>" method="POST" style="padding-top:20px;">
            <?php
            wp_nonce_field('update-options');
            settings_fields($tab);
            do_settings_sections($tab);
            submit_button();
            ?>
        </form>
    </div>
<?php
}

add_filter('plugin_action_links_' . SIMPLERWC_PLUGIN_BASENAME, 'simplerwc_add_plugin_page_settings_link');

function simplerwc_add_plugin_page_settings_link($links)
{
    return array_merge([
        '<a href="' . admin_url('options-general.php?page=simpler_management') . '">' . __('Settings') . '</a>'
    ], $links);
}
