<?php

add_action('init', 'simplerwc_woocommerce_order_created');

function simplerwc_woocommerce_order_created()
{
    if (!isset($_GET['simpler_order_created'])) {
        return;
    }

    $redirect_url = wc_get_endpoint_url('order-received', null, wc_get_checkout_url());

    $order_id = absint($_GET['simpler_order_created']);
    $order = wc_get_order($order_id);
    if ($order) {
        $redirect_url = $order->get_checkout_order_received_url();
    }

    WC()->cart->empty_cart();
    wp_safe_redirect($redirect_url);
    exit;
}

add_action('woocommerce_order_refunded', 'simplerwc_woocommerce_order_refunded');

/**
 * Send a webhook to Simpler when an order is refunded.
 *
 * @param $order_id
 */
function simplerwc_woocommerce_order_refunded($order_id)
{
    (new WP_Http())->post(SIMPLERWC_REFUND_HOST, [
        'body'     => json_encode(['order_id' => $order_id]),
        'headers'  => [
            'Authorization' => 'Basic ' . base64_encode(\get_option('simpler_api_key') . ':' . \get_option('simpler_api_secret'))
        ],
        'blocking' => false
    ]);
}
