<?php

/**
 * Plugin Name: Simpler Checkout
 * Plugin URI: https://simpler.so/
 * Author: Simpler
 * Author URI: https://simpler.so
 * Description: The Simpler Checkout button lets your customers complete their purchases in seconds, in any device or browser and without a password.
 * Version: 0.2.0
 * Requires at least: 5.1
 * Requires PHP: 7.0
 * License: GPLv3
 * License URI: https://www.gnu.org/licenses/old-licenses/gpl-3.0.html
 *
 * @package Simpler
 */

defined('ABSPATH') || exit;

define('SIMPLERWC_PATH', plugin_dir_path(__FILE__));
define('SIMPLERWC_URL', plugin_dir_url(__FILE__));
define('SIMPLERWC_PLUGIN_BASENAME', plugin_basename(__FILE__));

const SIMPLERWC_DEFAULT_ROOT_FQDN = 'simpler.so';
const SIMPLERWC_VERSION           = '0.2.0';
const SIMPLERWC_CHECKOUT_HOST     = 'https://checkout.' . SIMPLERWC_DEFAULT_ROOT_FQDN;
const SIMPLERWC_REFUND_HOST       = 'https://merchants.' . SIMPLERWC_DEFAULT_ROOT_FQDN . '/v1/refunds';

require_once SIMPLERWC_PATH . 'includes/woocommerce.php';

if (simplerwc_is_woocommerce_active()) {
    if (simplerwc_are_permalinks_disabled()) {
        simplerwc_admin_notice_permalinks_are_disabled();
    }

    if (!simplerwc_check_simpler_configured()) {
        simplerwc_admin_notice_incomplete_configuration();
    }

    /*
	 * Composer provides a convenient, automatically generated class loader for
	 * our plugin. We'll require it here so that we don't have to worry about manual
	 * loading any of our classes later on.
	 */
    require_once SIMPLERWC_PATH . 'vendor/autoload.php';
    require_once SIMPLERWC_PATH . 'includes/hooks.php';
    require_once SIMPLERWC_PATH . 'includes/admin.php';
    require_once SIMPLERWC_PATH . 'includes/assets.php';
    require_once SIMPLERWC_PATH . 'includes/button.php';
    require_once SIMPLERWC_PATH . 'includes/routes.php';
    require_once SIMPLERWC_PATH . 'templates/simpler-button.php';
} else {
    simplerwc_admin_notice_woocommerce_is_missing();
}
